class MMAddress
  attr_accessor :street, :city, :area, :region, :state, :postal_code, :zip, :display_name, :country_code, :qs

  def initialize( a = {} )
    if a.nil?
      return
    end
    if a[:street]
      self.street = a[:street]
    end
    if a[:city]
      self.city = a[:city]
    end
    if a[:area]
      self.area = a[:area]
    end
    if a[:region]
      self.region = a[:region]
    end
    if a[:state]
      self.state = a[:state]
    end
    if a[:postal_code]
      self.postal_code = a[:postal_code]
    end
    if a[:zip]
      self.zip = a[:zip]
    end
    if a[:display_name]
      self.display_name = a[:display_name]
    end
    if a[:country_code]
      self.country_code = a[:country_code]
    end
    if a[:qs]
      self.qs = a[:qs]
    end
  end

  def fromJSON( json )
    if json.nil?
      return
    end
    self.street = json['street']
    self.city = json['city']
    self.area = json['area']
    self.region = json['region']
    self.state = json['state']
    self.postal_code = json['postal_code']
    self.zip = json['zip']
    self.display_name = json['display_name']
    self.country_code = json['country_code']
    self.qs = json['qs']
  end

  def to_json(*a)
    {                                                                                                                                                                                               
      "street" => self.street,
      "city" => self.city,
      "area" => self.area,
      "region" => self.region,
      "state" => self.state,
      "postal_code" => self.postal_code,
      "zip" => self.zip,
      "display_name" => self.display_name,
      "country_code" => self.country_code,
      "qs" => self.qs
    }.to_json(*a)
  end

  def copy
    cp = MMAddress.new
    cp.street = self.street
    cp.city = self.city
    cp.area = self.area
    cp.region = self.region
    cp.state = self.state
    cp.postal_code = self.postal_code
    cp.zip = self.zip
    cp.display_name = self.display_name
    cp.country_code = self.country_code
    cp.qs = self.qs
    return cp
  end

  def toAPIQueryString( postfix = "" )
    self.toGeocodeQueryString( posfix )
  end

  def toGeocodeQueryString( postfix = "" )
    url = ""
    postfix = postfix.to_s
    if postfix != ""
      postfix = "_"+postfix
    end
    if self.qs and self.qs != ""
      url += "&qs"+postfix+"="+URI.escape(self.qs,/[^0-9a-zA-Z\-]/)
    end
    if self.street and self.street != ""
      url += "&street"+postfix+"="+URI.escape(self.street,/[^0-9a-zA-Z\-]/)
    end
    if self.city and self.city != ""
      url += "&city"+postfix+"="+URI.escape(self.city,/[^0-9a-zA-Z\-]/)
    end
    if self.area and self.area != ""
      url += "&area"+postfix+"="+URI.escape(self.area,/[^0-9a-zA-Z\-]/)
    end
    if self.region and self.region != ""
      url += "&region"+postfix+"="+URI.escape(self.region,/[^0-9a-zA-Z\-]/)
    end
    if self.state and self.state != ""
      url += "&state"+postfix+"="+URI.escape(self.state,/[^0-9a-zA-Z\-]/)
    end
    if self.postal_code and self.postal_code != ""
      url += "&postal_code"+postfix+"="+URI.escape(self.postal_code,/[^0-9a-zA-Z\-]/)
    end
    if self.zip and self.zip != ""
      url += "&zip"+postfix+"="+URI.escape(self.zip,/[^0-9a-zA-Z\-]/)
    end
    if self.display_name and self.display_name != ""
      url += "&display_name"+postfix+"="+URI.escape(self.display_name,/[^0-9a-zA-Z\-]/)
    end
    if self.country_code and self.country_code != ""
      url += "&country_code"+postfix+"="+URI.escape(self.country_code,/[^0-9a-zA-Z\-]/)
    end
    return url
  end

  def to_s
    return self.display_name
  end
end
