class MMWhereAmI
  require 'json'
  require 'MMGeneral'
  def self.search( lat, lon, zoom = nil )
    if zoom.nil?
      zoom = 16
    end
    merc = MMGeneral.latLonToMercator( lat, lon )
    tile = MMGeneral.coordToTile( merc[:x], merc[:y], zoom)
    path_str = '/API/WhereAmI/1.2/'+MM_CLIENT_NAME+'?output=json&zoom='+zoom.to_s+'&lat='+lat.to_s+'&lon='+lon.to_s+'&x='+tile[:x].to_s+'&y='+tile[:y].to_s
    print path_str+"\n"
    res = Net::HTTP.start( MM_HOST_NAME, 80 ) { |http|
      http.get(path_str)
    }
    results = JSON.parse( res.body )
    if results and results['record_sets'] and results['record_sets']['mm.whereami'] and results['record_sets']['mm.whereami']['records'] 
      record = results['record_sets']['mm.whereami']['records'] 
      if record
        record = record[0]
      end
    end
    if record
      result = {}
      result['country_code'] = record['iso']
      result['country_bb'] = record['country_bb']
      result['state'] = record['admin1']
      result['state_bb'] = record['admin1_bb']
      result['local_area'] = record['name']
      result['point'] = record['point']
    end
    return result
  end
end
